varying highp vec2 textureCoordinate;

uniform sampler2D vTexture;
uniform sampler2D maskTexture1;
uniform sampler2D maskTexture2;

uniform highp float intensity;
uniform highp float proportion;

uniform int useOrigin;

void main(){
    highp vec4 textureColor = texture2D(vTexture, textureCoordinate);
    highp float blueColor = textureColor.b * 63.0;
    highp vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);

    highp vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);
    highp vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);
    highp vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

    lowp vec4 newColor1;
    lowp vec4 newColor2;


    if (useOrigin == 3) {
        gl_FragColor = textureColor;

    } else {

      if (textureCoordinate.x < proportion) {

            if (useOrigin == 1) {
                gl_FragColor = textureColor;
            } else {
                newColor1 = texture2D(maskTexture1, texPos1);
                newColor2 =  texture2D(maskTexture1, texPos2);

                lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
                gl_FragColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), intensity);

            }


         } else {
             if (useOrigin == 2) {
                gl_FragColor = textureColor;
             } else {
                newColor1 = texture2D(maskTexture2, texPos1);
                newColor2 =  texture2D(maskTexture2, texPos2);

                lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
                gl_FragColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), intensity);

             }

          }
    }

}